Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 85547 - app-crypt/gnupg: Timing attack
Summary: app-crypt/gnupg: Timing attack
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Security
Classification: Unclassified
Component: Vulnerabilities (show other bugs)
Hardware: All All
: High minor (vote)
Assignee: Gentoo Security
URL: http://www.kb.cert.org/vuls/id/303094
Whiteboard: A4 [glsa] koon
Keywords:
Depends on:
Blocks:
 
Reported: 2005-03-16 11:51 UTC by Thierry Carrez (RETIRED)
Modified: 2006-03-23 19:36 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
compile error on ppc64 (gnupg-compile-output.txt,49.25 KB, text/plain)
2005-03-20 07:19 UTC, Markus Rothe (RETIRED)
no flags Details
config.log on ppc64 (config.log,180.51 KB, text/plain)
2005-03-23 03:04 UTC, Markus Rothe (RETIRED)
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Thierry Carrez (RETIRED) gentoo-dev 2005-03-16 11:51:57 UTC
The OpenPGP protocol is vulnerable to a timing-attack in order to gain plain text from cipher text.  The timing difference appears as a side effect of the so-called "quick scan" and is only exploitable on systems that accept an arbitrary amount of cipher text for automatic decryption.
Comment 1 Thierry Carrez (RETIRED) gentoo-dev 2005-03-16 11:58:51 UTC
CAN-2005-0366
Fixed in 1.2.8 and 1.4.1, patches @
http://lists.gnupg.org/pipermail/gnupg-announce/2005q1/000191.html

Tavis / crypto herd: please bump ?
Comment 2 Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2005-03-16 12:05:37 UTC
I'm working on a 1.4.1 ebuild already, should be available shortly.
Comment 3 Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2005-03-16 14:36:27 UTC
1.4.1 is in the tree now.
Comment 4 Thierry Carrez (RETIRED) gentoo-dev 2005-03-17 00:51:31 UTC
Arches, please test and (if possible) mark gnupg-1.4.1 stable. If you think we rather need to include 1.2.8 (also fixed), please tell us too :)
Comment 5 Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2005-03-17 01:10:36 UTC
FYI: Upstream has declared 1.4 as the stable line.

Although Koon noted 1.2.8 as released, it's not available on the upstream FTP presently.
Comment 6 Michael Hanselmann (hansmi) (RETIRED) gentoo-dev 2005-03-17 09:57:14 UTC
Stable on ppc.
Comment 7 Gustavo Zacarias (RETIRED) gentoo-dev 2005-03-17 10:05:19 UTC
sparc stable.
Comment 8 René Nussbaumer (RETIRED) gentoo-dev 2005-03-17 10:42:22 UTC
compiles and works.
Comment 9 René Nussbaumer (RETIRED) gentoo-dev 2005-03-17 10:42:59 UTC
compiles and works for me on hppa I meant
Comment 10 Michael Hanselmann (hansmi) (RETIRED) gentoo-dev 2005-03-17 10:45:48 UTC
Stable on hppa.
Comment 11 Marcus D. Hanwell (RETIRED) gentoo-dev 2005-03-17 11:46:50 UTC
Stable on amd64.
Comment 12 Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2005-03-17 16:47:08 UTC
x86 done.
Comment 13 Hasan Khalil (RETIRED) gentoo-dev 2005-03-17 18:47:41 UTC
ppc-macos done. Also put in a fix for collission-protect systems - currently only applied if USE contains ppc-macos - that might better be done regardless of keyword.
Comment 14 Markus Rothe (RETIRED) gentoo-dev 2005-03-20 07:19:38 UTC
Created attachment 53934 [details]
compile error on ppc64

this won't compile on ppc64. Output is attached.

I think we that 1.2.8 version koon mentioned before for ppc64.
Comment 15 Thierry Carrez (RETIRED) gentoo-dev 2005-03-22 14:01:41 UTC
Robin: would it be possible to patch the current 1.2.6 with the patches @ http://lists.gnupg.org/pipermail/gnupg-announce/2005q1/000191.html to unblock ppc64 ?

alpha: please test and mark stable
Comment 16 Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2005-03-22 14:11:05 UTC
ppc64: could you please post your 'emerge info' and attach the config.log?
I saw this once while building the src_test stuff for gnupg, but it was just a bad  build (I didn't clean the dir properly).
Comment 17 Bryan Østergaard (RETIRED) gentoo-dev 2005-03-22 14:43:51 UTC
Stable on alpha.
Comment 18 Thierry Carrez (RETIRED) gentoo-dev 2005-03-23 00:32:28 UTC
I vote for a GLSA on this one.
Comment 19 Markus Rothe (RETIRED) gentoo-dev 2005-03-23 03:04:46 UTC
Created attachment 54216 [details]
config.log on ppc64

 # emerge --info
Portage 2.0.51.19 (default-linux/ppc64/2005.0, gcc-3.4.3,
glibc-2.3.4.20041102-r1, 2.6.9-gentoo-r9 ppc64)
=================================================================
System uname: 2.6.9-gentoo-r9 ppc64 PPC970, altivec supported
Gentoo Base System version 1.6.10
Python: 	     dev-lang/python-2.3.3-r2 [2.3.3 (#1, Mar 19 2005,
14:18:56)]
dev-lang/python:     2.3.3-r2
sys-devel/autoconf:  2.59-r6, 2.13
sys-devel/automake:  1.5, 1.6.3, 1.8.5-r3, 1.7.9-r1, 1.4_p6, 1.9.4
sys-devel/binutils:  2.15.90.0.3-r3
sys-devel/libtool:   1.5.10-r4
virtual/os-headers:  2.6.8.1-r2
ACCEPT_KEYWORDS="ppc64"
AUTOCLEAN="yes"
CFLAGS="-mcpu=G5 -O3 -pipe -fsigned-char -mabi=altivec"
CHOST="powerpc64-unknown-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/2/share/config /usr/kde/3.3/env
/usr/kde/3.3/share/config /usr/kde/3.3/shutdown /usr/kde/3/share/config
/usr/lib/X11/xkb /usr/share/config /usr/share/texmf/dvipdfm/config/
/usr/share/texmf/dvips/config/ /usr/share/texmf/tex/generic/config/
/usr/share/texmf/tex/platex/config/ /usr/share/texmf/xdvi/ /var/qmail/control"
CONFIG_PROTECT_MASK="/etc/gconf /etc/terminfo /etc/env.d"
CXXFLAGS="-mcpu=G5 -O3 -pipe -fsigned-char -mabi=altivec"
DISTDIR="/usr/portage/distfiles"
FEATURES="autoaddcvs autoconfig ccache cvs distlocks sandbox sfperms"
GENTOO_MIRRORS="http://linux.rz.ruhr-uni-bochum.de/download/gentoo-mirror/
http://ftp-stud.fht-esslingen.de/pub/Mirrors/gentoo/"
MAKEOPTS="-j3"
PKGDIR="/usr/portage/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="X altivec apache2 audiofile bash-completion bcmath berkdb bitmap-fonts
bzip2 bzlib calendar cdb cdparanoia cdr cdrom chroot client crypt cups curl dba
dedicated dga dict dio divx4linux dv dvd dvdr dvdread encode exif fam fame
fbcon ffmpeg flac flatfile foomaticdb fortran fpx freetype ftp gcc-libffi gcj
gd gdbm gif gimp gimpprint glade gnokii gnuplot gnustep gphoto2 gpm graphviz gs
gstreamer gtk gtk2 iconv icq ieee1394 image imagemagick imap imlib2 ipv6
ipv6arpa jabber java javacomm javamail javascript jbig jpeg jpeg2k kde
kdeenablefinal kerberos latex libwww live maildir md5sum mhash mime mimencode
mixer mjpeg mng motif mozsvg mp3 mpeg mpeg4 mpi music native ncurses neXt nls
nocardbus nowin nptl nptlonly objc oggvorbis openal opengl openssh pam pdf
pdflib perl php physfs plotutils png pnp portaudio posix povray ppc64 ppds
procmail python qt quicktime quotas quotes radius readline rtc sasl sdk serial
server session silc slang smime sms sndfile sockets sounds spell ssl svg tcpd
tetex tga theora tidy tiff tools transcode truetype truetype-fonts type1-fonts
uml unicode uptimed usb v4l v4l2 vcd vhosts videos vidix vim wmf wxwindows
xanim xchatdccserver xchattext xine xml2 xmms xosd xpm xprint xscreensaver xsl
xv xvid xvmc zlib"
Unset:	ASFLAGS, CBUILD, CTARGET, LANG, LC_ALL, LDFLAGS, PORTDIR_OVERLAY

 #
Comment 20 Markus Rothe (RETIRED) gentoo-dev 2005-03-23 03:05:53 UTC
I forgot to say, that I already tried C(XX)FLAGS="-O2"...
Comment 21 Sune Kloppenborg Jeppesen gentoo-dev 2005-03-23 08:20:26 UTC
I vote YES for a GLSA on this one.
Comment 22 Robin Johnson archtester Gentoo Infrastructure gentoo-dev Security 2005-03-24 02:03:45 UTC
ppc64: could you please add --disable-asm to the configure options, and see if gnupg builds and passes the src_test?
I think it should fix it for you.
Comment 23 Markus Rothe (RETIRED) gentoo-dev 2005-03-24 12:45:11 UTC
robin: thx! that did the trick!

Stable on ppc64.
Comment 24 Thierry Carrez (RETIRED) gentoo-dev 2005-03-24 14:04:03 UTC
GLSA 200503-29
arm,ia64,s390 should mark stable to benefit from GLSA